var gAlert = null;

function onLoad()
{
	var arguments = window.arguments[0];
	document.title = arguments.title;
	var desc = document.getElementById("CASAlertDesc");
	var text = document.createTextNode(arguments.desc);
	desc.appendChild(text);
	gAlert = new CASAlert(arguments);
}

window.addEventListener("dialogaccept", function(event) {
	var ret = gAlert.onOK();
	if (!ret) {
		event.preventDefault();
	}
});

window.addEventListener("dialogcancel", function(event) {
	var ret = gAlert.onCancel(event);
	if (!ret) {
		event.preventDefault();
	}
});

function CASAlert(arg)
{
	this.arg = arg;
	this.richlist = arg.richlist;
	
	this.list = document.getElementById("CASAlertListRich");
	this.doubleline = arg.doubleline;
	this.initList(arg.items);
	if (!arg.selbutton) {
		document.getElementById("CASButtonSelAll").setAttribute("collapsed",true);
		document.getElementById("CASButtonClrSel").setAttribute("collapsed",true);
	} else {
		document.getElementById("CASButtonSelAll").removeAttribute("collapsed");
		document.getElementById("CASButtonClrSel").removeAttribute("collapsed");
	}
}

CASAlert.prototype.onOK = function()
{
	var items;
	if (this.arg.checkbox) {
		items = this.getChecked(this.arg.getSelected);
	} else {
		items = this.getSelected(this.arg.getSelected);
	}
	this.arg.okCallback(items);
	this.arg.isOK = true;
	
	return true;
}

CASAlert.prototype.onCancel = function()
{
	this.arg.isOK = false;
	return true;
}


CASAlert.prototype.initList = function(items)
{
	this.list.setAttribute("seltype", this.arg.seltype);
	this.list.setAttribute("rows", this.arg.rows.toString());

	var length = items.length;
	for (var i=0; i<length; i++){
		var item = items[i];
		var listitem = document.createElement("richlistitem");
		if (this.doubleline) {
			var line0 = document.createElement("vbox");
			var check1 = document.createElement("checkbox");
			check1.setAttribute("label", item.label);
			check1.setAttribute("crop", "end");
			check1.setAttribute("id", item.checkitem);
			line0.appendChild(check1);
			listitem.appendChild(line0);

			var line2 = document.createElement("hbox");
			var spc2 = document.createElement("spacer");
			spc2.style.width = "2em";
			line2.appendChild(spc2);
			var text2 = document.createElement("label");
			text2.setAttribute("value", item.label2);
			text2.setAttribute("crop", "end");
			line2.appendChild(text2);
			line0.appendChild(line2);
			listitem.appendChild(line0);

			if (item.value){
				listitem.value = item.value;
			}
			this.list.appendChild(listitem);
			if (item.checked) {
				var checkitem = document.getElementById(item.checkitem);
				checkitem.setAttribute("checked", "true");
				listitem.setAttribute("checkitem", item.checkitem);
			}
		} else {
			if (this.arg.checkbox) {
				var checkbox = document.createElement("checkbox");
				checkbox.setAttribute("id","checkitem"+i);
				if (item.checked) {
    			checkbox.setAttribute("checked", "true");
				}
    		listitem.appendChild(checkbox);
				listitem.setAttribute("checkitem", "checkitem"+i);
			}
			
			var label = document.createElement("label");
			label.setAttribute("value", item.label);
			listitem.appendChild(label);
			
			if (item.value){
				listitem.value = item.value;
			}
			this.list.appendChild(listitem);		

			listitem.setAttribute("crop", "end");
		}
		if (item.tip) {
			listitem.setAttribute("tooltiptext", item.tip);
		}
	}
}

CASAlert.prototype.checkAll = function(check)
{
	var cnt = this.list.getRowCount();
	for (var i=0; i<cnt; i++) {
		var item = document.getElementById(this.list.getItemAtIndex(i).getAttribute("checkitem"));
		if (check) item.setAttribute("checked", "true");
		else item.removeAttribute("checked");
	}
}

CASAlert.prototype.clearSelection = function()
{
	this.list.clearSelection();
}

CASAlert.prototype.selectAll = function()
{
	if (!this.doubleline) this.list.selectAll();
}

CASAlert.prototype.getChecked = function(checked)
{
	var ret = new Array();
	var cnt = this.list.getRowCount();
	for (var i=0; i<cnt; i++) {
		var item = this.list.getItemAtIndex(i);

		var checkitem = document.getElementById(item.getAttribute("checkitem"));
		var isChecked = checkitem.getAttribute("checked") == "true";
		if (isChecked == checked) ret.push(item);
	}
	
	return ret;
}

CASAlert.prototype.getSelected = function(selected)
{
	if (selected) {
		if (this.doubleline) {
			return this.list.selectedItem;
		} else {
			return this.list.selectedItems;
		}
	}
	
	//get unselected items
	var ret = new Array();
	var cnt = this.list.getRowCount();
	for (var i=0; i<cnt; i++) {
		var item = this.list.getItemAtIndex(i);
		var isSelected = item.getAttribute("selected") == "true";
		if (!isSelected) ret.push(item);
	}

	return ret;
}